<template>
  <el-breadcrumb class="app-breadcrumb"
                 separator="/">
    <!-- <transition-group name="breadcrumb">
      <el-breadcrumb-item v-for="(item,index) in levelList" :key="item.path">
        <span v-if="item.redirect==='noRedirect'||index==levelList.length-1" class="no-redirect">{{ item.meta.title }}</span>
        <a v-else @click.prevent="handleLink(item)">{{ item.meta.title }}</a>
      </el-breadcrumb-item>
    </transition-group> -->

    <div @click="goBack"
         class="backIcon">
      <i class="el-icon-back"></i>
      <!-- <el-page-header v-if="isMouse"
                      class="theheader"
                      title=""
                      style="color: #C8161D"
                      @back="goBack">
      </el-page-header> -->
    </div>
  </el-breadcrumb>
</template>

<script>
import pathToRegexp from 'path-to-regexp'

export default {
  data() {
    return {
      levelList: null,
      matched: [],
      tabActive: '',
      isMouse: true,
    }
  },
  watch: {
    $route() {
      this.getBreadcrumb()
    },
  },
  created() {
    this.getBreadcrumb()
  },
  methods: {
    goBack() {
      // this.$store.dispatch('tagsView/delView', this.$route)
      this.$router.go(-1)
    },
    getBreadcrumb() {
      // only show routes with meta.title
      let matched = this.$route.matched.filter(
        (item) => item.meta && item.meta.title
      )
      const first = matched[0]

      // if (!this.isDashboard(first)) {
      //   matched = [{ path: '/dashboard', meta: { title: 'Dashboard' }}].concat(matched)
      // }
      let hasMenu = this.matched.some((item) => {
        return item.path == matched[matched.length - 1].path
      })
      if (matched[matched.length - 1].path == this.$route.path) {
        if (!hasMenu) {
          this.matched.push(matched[matched.length - 1])
        }
        this.tabActive = matched[matched.length - 1].path
        if (this.tabActive == '/dashboard') {
          this.isMouse = false
        } else {
          this.isMouse = true
        }
      }

      this.levelList = matched.filter(
        (item) => item.meta && item.meta.title && item.meta.breadcrumb !== false
      )
    },
    isDashboard(route) {
      const name = route && route.name
      if (!name) {
        return false
      }
      return name.trim().toLocaleLowerCase() === 'Dashboard'.toLocaleLowerCase()
    },
    pathCompile(path) {
      // To solve this problem https://github.com/PanJiaChen/vue-element-admin/issues/561
      const { params } = this.$route
      var toPath = pathToRegexp.compile(path)
      return toPath(params)
    },
    handleLink(item) {
      const { redirect, path } = item
      if (redirect) {
        this.$router.push(redirect)
        return
      }
      this.$router.push(this.pathCompile(path))
    },
  },
}
</script>

<style lang="scss" scoped>
// ::v-deep .el-page-header__left .el-icon-back {
//   font-size: 24px;
// }
// ::v-deep .el-page-header__left::after {
//   display: none;
// }
.backIcon {
  width: 18px;
  height: 18px;
  background: #c8161d;
  color: #fff;
  position: relative;
  font-size: 14px;
  border-radius: 50%;
  margin-left: 10px;
  ::v-deep .el-icon-back {
    position: absolute;
    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%);
  }
}

.theheader {
  height: 50px;
  display: flex;
  align-items: center;
}
.app-breadcrumb.el-breadcrumb {
  display: inline-block;
  font-size: 14px;
  line-height: 50px;
  margin-left: 8px;

  .no-redirect {
    color: #97a8be;
    cursor: text;
  }
}
</style>
